import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Sonar_sans_com extends PApplet {

// USER DEFINED size of the scanner (width of the window)
int scannerSize = 800;
int scannerLineWidth = 4; // 1/100\ufffd of size for example
int scannerDotRadius = 2; // 1/200\ufffd of size for example
// Computed radius (dependant of the size)
int radius = scannerSize / 2 - 20;
/** Variables **/
int theta = 0; // current value of the detection angle
int sens = 1;  // current value of the scanner direction 
// Store previous detection values
int[] previousdet = new int[181];
int[] detection = new int[181];
public void setup()
{  
  size(scannerSize,scannerSize/2);
  smooth();  //lissage
  strokeWeight(scannerLineWidth);
}
// Convert 10 bits analog value into value on the scanner radius
public int getDistance(int val) 
{
    return (int)(val / 1023.0f * radius) - 1;
}

public void receiveDistance()  //------------------------------------
{
 detection[theta] = getDistance(0x1FF);    
}
//----------------------------------------------------------------
public void draw()
{
  fill(250);
  text("+60\u00b0",width-width/15,height-height/2);
  text("-60\u00b0",width/20,height-height/2);
  text("+45\u00b0",width-width/6,height/4);
  text("-45\u00b0",width/7,height/4);
  text("+30\u00b0",width-width/3,height/20);
  text("-30\u00b0",width/3,height/20);
  text("0",width/2,height/40);
  translate(width/2, height-10);    // retournement de 180\u00b0
  rotate(-3.14f);
  //  Rectangle noir
  fill(0,10);
  //rect(-200, -10, width, height);
  rect(-width/2, -10, width, height);
  
  // Centre du scanner
  fill(200); //
  ellipse(0,0,10,10);
  
  // Convert polar to cartesian
  float x = radius * cos(radians(theta));
  float y = radius * sin(radians(theta));

  // Affichage de la ligne de detection courante
  stroke(250,100,0);
  line(0,0,x,y);

  // Reception sur liaison s\ufffdrie
  receiveDistance();             

  // Affichage des distances recues
  noStroke();
  for (int i=0; i<180; i++)
  {    
    if (detection[i] != -1 && detection[i] != 0)
    {
      fill(calculeIntense(i));
      float dx = detection[i]*cos(radians(i));
      float dy = detection[i]*sin(radians(i));   
      ellipse(dx,dy,scannerDotRadius,scannerDotRadius);
    }
  }
  // Changement de sens automatique
  if (sens == 1) 
  {  
    theta++;
    if (theta == 180)
    {
      sens = 0;
    }
  } 
  else {
    theta--;
    if (theta == 0)
    {
      sens = 1;
    }
  }
}
// Retour au noir apr\u00e9s d\u00e9tection d'une cible
public int calculeIntense(int i)
{  
  if (sens == 1)
  {  
    //
    if (i < theta+20 && i > theta - 60)
    {
      return floor((60 - theta + i)/60.0f*255.0f);      
    }
  } 
  else {
    //
    if (i > theta-20 && i < theta + 60)
    {
      return floor((60 - i + theta)/60.0f*255.0f);
    }     
  } 
  return 0;
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#D4D0C8", "Sonar_sans_com" });
  }
}
